// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.21.12
// source: carp.proto

package proto

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// PluginClient is the client API for Plugin service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type PluginClient interface {
	Configure(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationResponse, error)
	RequestStart(ctx context.Context, opts ...grpc.CallOption) (Plugin_RequestStartClient, error)
	RequestEnd(ctx context.Context, opts ...grpc.CallOption) (Plugin_RequestEndClient, error)
	CacheStart(ctx context.Context, opts ...grpc.CallOption) (Plugin_CacheStartClient, error)
	CacheEnd(ctx context.Context, opts ...grpc.CallOption) (Plugin_CacheEndClient, error)
}

type pluginClient struct {
	cc grpc.ClientConnInterface
}

func NewPluginClient(cc grpc.ClientConnInterface) PluginClient {
	return &pluginClient{cc}
}

func (c *pluginClient) Configure(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationResponse, error) {
	out := new(ConfigurationResponse)
	err := c.cc.Invoke(ctx, "/main.Plugin/Configure", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginClient) RequestStart(ctx context.Context, opts ...grpc.CallOption) (Plugin_RequestStartClient, error) {
	stream, err := c.cc.NewStream(ctx, &Plugin_ServiceDesc.Streams[0], "/main.Plugin/RequestStart", opts...)
	if err != nil {
		return nil, err
	}
	x := &pluginRequestStartClient{stream}
	return x, nil
}

type Plugin_RequestStartClient interface {
	Send(*HttpRequest) error
	Recv() (*RequestStartResult, error)
	grpc.ClientStream
}

type pluginRequestStartClient struct {
	grpc.ClientStream
}

func (x *pluginRequestStartClient) Send(m *HttpRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *pluginRequestStartClient) Recv() (*RequestStartResult, error) {
	m := new(RequestStartResult)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *pluginClient) RequestEnd(ctx context.Context, opts ...grpc.CallOption) (Plugin_RequestEndClient, error) {
	stream, err := c.cc.NewStream(ctx, &Plugin_ServiceDesc.Streams[1], "/main.Plugin/RequestEnd", opts...)
	if err != nil {
		return nil, err
	}
	x := &pluginRequestEndClient{stream}
	return x, nil
}

type Plugin_RequestEndClient interface {
	Send(*HttpResponse) error
	Recv() (*RequestEndResult, error)
	grpc.ClientStream
}

type pluginRequestEndClient struct {
	grpc.ClientStream
}

func (x *pluginRequestEndClient) Send(m *HttpResponse) error {
	return x.ClientStream.SendMsg(m)
}

func (x *pluginRequestEndClient) Recv() (*RequestEndResult, error) {
	m := new(RequestEndResult)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *pluginClient) CacheStart(ctx context.Context, opts ...grpc.CallOption) (Plugin_CacheStartClient, error) {
	stream, err := c.cc.NewStream(ctx, &Plugin_ServiceDesc.Streams[2], "/main.Plugin/CacheStart", opts...)
	if err != nil {
		return nil, err
	}
	x := &pluginCacheStartClient{stream}
	return x, nil
}

type Plugin_CacheStartClient interface {
	Send(*CacheRequest) error
	Recv() (*CacheStartResult, error)
	grpc.ClientStream
}

type pluginCacheStartClient struct {
	grpc.ClientStream
}

func (x *pluginCacheStartClient) Send(m *CacheRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *pluginCacheStartClient) Recv() (*CacheStartResult, error) {
	m := new(CacheStartResult)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *pluginClient) CacheEnd(ctx context.Context, opts ...grpc.CallOption) (Plugin_CacheEndClient, error) {
	stream, err := c.cc.NewStream(ctx, &Plugin_ServiceDesc.Streams[3], "/main.Plugin/CacheEnd", opts...)
	if err != nil {
		return nil, err
	}
	x := &pluginCacheEndClient{stream}
	return x, nil
}

type Plugin_CacheEndClient interface {
	Send(*CacheResponse) error
	Recv() (*CacheVoidResponse, error)
	grpc.ClientStream
}

type pluginCacheEndClient struct {
	grpc.ClientStream
}

func (x *pluginCacheEndClient) Send(m *CacheResponse) error {
	return x.ClientStream.SendMsg(m)
}

func (x *pluginCacheEndClient) Recv() (*CacheVoidResponse, error) {
	m := new(CacheVoidResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// PluginServer is the server API for Plugin service.
// All implementations must embed UnimplementedPluginServer
// for forward compatibility
type PluginServer interface {
	Configure(context.Context, *ConfigurationRequest) (*ConfigurationResponse, error)
	RequestStart(Plugin_RequestStartServer) error
	RequestEnd(Plugin_RequestEndServer) error
	CacheStart(Plugin_CacheStartServer) error
	CacheEnd(Plugin_CacheEndServer) error
	mustEmbedUnimplementedPluginServer()
}

// UnimplementedPluginServer must be embedded to have forward compatible implementations.
type UnimplementedPluginServer struct {
}

func (UnimplementedPluginServer) Configure(context.Context, *ConfigurationRequest) (*ConfigurationResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Configure not implemented")
}
func (UnimplementedPluginServer) RequestStart(Plugin_RequestStartServer) error {
	return status.Errorf(codes.Unimplemented, "method RequestStart not implemented")
}
func (UnimplementedPluginServer) RequestEnd(Plugin_RequestEndServer) error {
	return status.Errorf(codes.Unimplemented, "method RequestEnd not implemented")
}
func (UnimplementedPluginServer) CacheStart(Plugin_CacheStartServer) error {
	return status.Errorf(codes.Unimplemented, "method CacheStart not implemented")
}
func (UnimplementedPluginServer) CacheEnd(Plugin_CacheEndServer) error {
	return status.Errorf(codes.Unimplemented, "method CacheEnd not implemented")
}
func (UnimplementedPluginServer) mustEmbedUnimplementedPluginServer() {}

// UnsafePluginServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PluginServer will
// result in compilation errors.
type UnsafePluginServer interface {
	mustEmbedUnimplementedPluginServer()
}

func RegisterPluginServer(s grpc.ServiceRegistrar, srv PluginServer) {
	s.RegisterService(&Plugin_ServiceDesc, srv)
}

func _Plugin_Configure_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConfigurationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginServer).Configure(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/main.Plugin/Configure",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginServer).Configure(ctx, req.(*ConfigurationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Plugin_RequestStart_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PluginServer).RequestStart(&pluginRequestStartServer{stream})
}

type Plugin_RequestStartServer interface {
	Send(*RequestStartResult) error
	Recv() (*HttpRequest, error)
	grpc.ServerStream
}

type pluginRequestStartServer struct {
	grpc.ServerStream
}

func (x *pluginRequestStartServer) Send(m *RequestStartResult) error {
	return x.ServerStream.SendMsg(m)
}

func (x *pluginRequestStartServer) Recv() (*HttpRequest, error) {
	m := new(HttpRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _Plugin_RequestEnd_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PluginServer).RequestEnd(&pluginRequestEndServer{stream})
}

type Plugin_RequestEndServer interface {
	Send(*RequestEndResult) error
	Recv() (*HttpResponse, error)
	grpc.ServerStream
}

type pluginRequestEndServer struct {
	grpc.ServerStream
}

func (x *pluginRequestEndServer) Send(m *RequestEndResult) error {
	return x.ServerStream.SendMsg(m)
}

func (x *pluginRequestEndServer) Recv() (*HttpResponse, error) {
	m := new(HttpResponse)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _Plugin_CacheStart_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PluginServer).CacheStart(&pluginCacheStartServer{stream})
}

type Plugin_CacheStartServer interface {
	Send(*CacheStartResult) error
	Recv() (*CacheRequest, error)
	grpc.ServerStream
}

type pluginCacheStartServer struct {
	grpc.ServerStream
}

func (x *pluginCacheStartServer) Send(m *CacheStartResult) error {
	return x.ServerStream.SendMsg(m)
}

func (x *pluginCacheStartServer) Recv() (*CacheRequest, error) {
	m := new(CacheRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _Plugin_CacheEnd_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PluginServer).CacheEnd(&pluginCacheEndServer{stream})
}

type Plugin_CacheEndServer interface {
	Send(*CacheVoidResponse) error
	Recv() (*CacheResponse, error)
	grpc.ServerStream
}

type pluginCacheEndServer struct {
	grpc.ServerStream
}

func (x *pluginCacheEndServer) Send(m *CacheVoidResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *pluginCacheEndServer) Recv() (*CacheResponse, error) {
	m := new(CacheResponse)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// Plugin_ServiceDesc is the grpc.ServiceDesc for Plugin service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Plugin_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "main.Plugin",
	HandlerType: (*PluginServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Configure",
			Handler:    _Plugin_Configure_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "RequestStart",
			Handler:       _Plugin_RequestStart_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
		{
			StreamName:    "RequestEnd",
			Handler:       _Plugin_RequestEnd_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
		{
			StreamName:    "CacheStart",
			Handler:       _Plugin_CacheStart_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
		{
			StreamName:    "CacheEnd",
			Handler:       _Plugin_CacheEnd_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "carp.proto",
}
